"use strict";
function puppeteerDelay(time) {
   return new Promise(function(resolve) { 
       setTimeout(resolve, time)
   });
}
const puppeteer = require('puppeteer');
(async () => {
  var args = process.argv.slice(2);
  process.on('unhandledRejection', up => { throw up })
  var argarr = ['--no-sandbox', '--disable-setuid-sandbox'];
  if(args[2] != 'default')
  {
      argarr.push("--user-agent=" + args[2]);
  }
  argarr.push("--proxy-server=socks5://127.0.0.1:9050");
  if(args[3] != 'default')
  {
      var cookies = args[3].split(';').reduce((cookieObject, cookieString) => {
   		let splitCookie = cookieString.split('=')
   		try {
   		  cookieObject[splitCookie[0].trim()] = decodeURIComponent(splitCookie[1])
   		} catch (error) {
   			cookieObject[splitCookie[0].trim()] = splitCookie[1]
   		}
   		return cookieObject
   	  }, []);
      await page.setCookie(cookies);
  }
  if(args[4] != 'default')
  {
      var xres = args[4].split(":");
      if(xres[1] != undefined)
      {
          var user = xres[0];
          var pass = xres[1];
          const auth = new Buffer(`${user}:${pass}`).toString('base64');
          await page.setExtraHTTPHeaders({
              'Authorization': `Basic ${auth}`                    
          });
      }
  }
  const browser = await puppeteer.launch({args: argarr});
  
  if(args[6] != '1')
  {
      //check if tor ok
      const page2 = await browser.newPage();
      if(args[5] != 'default')
      {
          await page2.setDefaultNavigationTimeout(args[5]);
      }
      await page2.goto('https://check.torproject.org/');
      const isUsingTor = await page2.$eval('body', el =>
          el.innerHTML.includes('Congratulations. This browser is configured to use Tor')
          );
      if (!isUsingTor) {
          console.log('CRAWLOMATIC NOT USING TOR!');
          await browser.close()
          return;
      }
  }
  //continue
  const page = await browser.newPage();
  if(args[5] != 'default')
  {
      await page.setDefaultNavigationTimeout(args[5]);
  }
  await page.goto(args[0], {waitUntil: 'networkidle2'});
  if(args[7] != 'default' && args[7] != '' && args[7] != '0')
  {
      await puppeteerDelay(args[7]);
  }
  let bodyHTML = await page.evaluate(() => document.body.innerHTML);
  console.log(bodyHTML);
  await browser.close();
})();